'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #323] on 7 September 2004 at 8:08:38 am'!
SketchMorph subclass: #NCSketchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsProjectsAndWorlds'!
!NCSketchMorph commentStamp: '<historical>' prior: 0!
I am a SketchMorph that has similar user interaction to the NCBasicShapeMorph (menus, etc.)
!


!NCSketchMorph methodsFor: 'menu' stamp: 'nk 6/15/2004 12:45'!
addGraphModelYellowButtonItemsTo: aCustomMenu event: evt

	self graphModel ifNotNilDo: [ :gc |
		gc addModelYellowButtonMenuItemsTo: aCustomMenu
				forMorph: self
				hand: evt hand.
			aCustomMenu addLine].

	^aCustomMenu! !

!NCSketchMorph methodsFor: 'menu' stamp: 'nk 6/15/2004 12:46'!
addModelYellowButtonItemsTo: aCustomMenu event: evt
	super addModelYellowButtonItemsTo: aCustomMenu event: evt.
	self addGraphModelYellowButtonItemsTo: aCustomMenu event: evt.! !

!NCSketchMorph methodsFor: 'menu' stamp: 'nk 6/12/2004 18:59'!
addYellowButtonMenuItemsTo: aCustomMenu event: evt
	super addYellowButtonMenuItemsTo: aCustomMenu event: evt.
	
	owner ifNotNil: [
	aCustomMenu
		add: 'move' target: evt hand selector: #attachMorph: argument: self;
		add: 'delete' target: self selector: #dismissMorph;
		add: 'resize' target: self selector: #resizeMorph: argument: evt;
		addLine
	].
	aCustomMenu
		add: 'properties...' target: self selector: #openAPropertySheet.
	(Smalltalk includesKey: #NCMakerButton) ifTrue: [
		aCustomMenu add: 'make button' action: #makeButton: ].
	aCustomMenu addLine.

	aCustomMenu
		defaultTarget: self;
		add: 'add mouse up action' action: #addMouseUpAction;
		add: 'remove mouse up action' action: #removeMouseUpAction.
	aCustomMenu addLine.
	
	self scalePoint ~= (1.0@1.0)
	ifTrue: [
		aCustomMenu
			add: 'restore size' target: self selector: #restoreSize.
	].
	
	owner ifNotNil: [ self addCustomMenuItems: aCustomMenu hand: evt hand ]
! !

!NCSketchMorph methodsFor: 'menu' stamp: 'nk 1/23/2004 15:32'!
hasYellowButtonMenu
	^true! !

!NCSketchMorph methodsFor: 'menu' stamp: 'nk 6/15/2002 10:10'!
restoreSize
	self scalePoint: 1.0@1.0
! !


!NCSketchMorph methodsFor: 'geometry' stamp: 'nk 4/15/2002 21:28'!
containsPoint: aPoint

	^ self bounds containsPoint: aPoint! !


!NCSketchMorph methodsFor: 'event handling' stamp: 'nk 6/15/2002 10:01'!
handlesKeyboard: anEvent
	anEvent keyValue == 27 ifTrue: [ ^true ].
	^super handlesKeyboard: anEvent
! !

!NCSketchMorph methodsFor: 'event handling' stamp: 'nk 6/15/2002 10:04'!
handlesMouseDown: anEvent
	"Make me movable with the shift pressed."
	anEvent yellowButtonPressed ifTrue: [ ^true ].
	^super handlesMouseDown: anEvent! !

!NCSketchMorph methodsFor: 'event handling' stamp: 'nk 6/24/2004 13:27'!
keyStroke: anEvent
	"Handle a keystroke event.  The default response is to let my eventHandler, if any, handle it."
	anEvent keyValue == 27 ifTrue: [ ^ self yellowButtonActivity: anEvent shiftPressed ].
	^super keyStroke: anEvent
! !

!NCSketchMorph methodsFor: 'event handling' stamp: 'nk 6/24/2004 13:27'!
mouseDown: evt
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed ].
	super mouseDown: evt
! !


!NCSketchMorph methodsFor: 'dropping-grabbing' stamp: 'nk 6/30/2002 13:13'!
justDroppedInto: aMorph event: evt
	self alignAttachmentPointsWithGridNear: evt position.
	super justDroppedInto: aMorph event: evt.
! !

!NCSketchMorph methodsFor: 'dropping-grabbing' stamp: 'nk 6/15/2002 21:30'!
newTransformationMorph
	^NCTransformationMorph new
! !


!NCSketchMorph methodsFor: 'submorphs-accessing' stamp: 'nk 1/26/2004 16:45'!
noteNewOwner: aMorph
	super noteNewOwner: aMorph.
	aMorph ifNil: [^self].
	self wantsGraphModel ifTrue: [
		aMorph graphContext ifNotNilDo: [ :gc | self ensureGraphModelInOwner: aMorph andContext:  gc ]].! !


!NCSketchMorph methodsFor: 'graphs' stamp: 'nk 1/26/2004 16:43'!
wantsGraphModel
	^true! !


!NCSketchMorph methodsFor: 'accessing' stamp: 'nk 6/12/2004 15:11'!
wantsSimpleSketchMorphHandles
	"Answer true if my halo's simple handles should include the simple sketch morph handles."
	^true! !
